<!doctype html>
<html>
<head>
<meta charset="utf-8">
<title>Documento sin título</title>
	<style type="text/css">
	
		canvas{
			width: 800px;
			height: 600px;
			background-color: bisque;
			display:block;
			margin:0px auto;
		}
	</style>
	<script type="text/javascript">
		var canvas;
		var ctx;
		var imgData;
		var foto=new Image();
		
		
		window.addEventListener("load",arranca);
		function arranca(){
			canvas=document.querySelector("#canvas");
			ctx=canvas.getContext("2d");
			
			cuadricula();
			
			copiar();
			ctx.fillStyle="RED"; //  todos los rellenos en este color
			ctx.fillRect(200,200,10,10); // dibujar rectangulo
			foto.src=canvas.toDataURL();
			
			limpiar();
			ctx.translate(400,300); // mi nuevo 0,0 es 400,300
			ctx.rotate(45);
			//pegar();
			
			/* me pega colocando las transformaciones */
			foto.onload=function(){
				ctx.drawImage(foto,-400,-300);
			}
			
			
			cuadricula();
			//ctx.fillStyle="RED";
			//ctx.fillRect(200,200,10,10);
			//pegar();
			
		}
		
		function limpiar(){
			ctx.clearRect(0,0,800,600);
		}
		
		function cuadricula(){
			for (var x=0; x<=800; x=x+20){
  				ctx.moveTo(x,0);
  				ctx.lineTo(x,600);

			}
			
			for (var y=0; y<=600; y=y+20){
  				ctx.moveTo(0,y);
  				ctx.lineTo(800,y);
			}
				ctx.lineWidth=1.5;
				ctx.strokeStyle = "blue";
				ctx.stroke();
		}
		
		
		
		function copiar(){
			imgData = ctx.getImageData(0,0,800,600);
		}
		
		function pegar(){
			ctx.putImageData(imgData, 15, 15);			
		}
		
	</script>

</head>

<body>
<canvas id="canvas" width="800" height="600">
	
</canvas>
</body>
</html>
